*SublimeHaskell* 2.0.1
======================

## 2.0.4:

**Issue 362**: `HLint` can produce diagnostics that do not include a source file name, which generally indicates a potential command line issue or warning. Noticed by @trha by putting `{-# OPTIONS_GHC -O2 #-}` at the top of a source file. If no source file is included, *SublimeHaskell* will report `<no file/command line>` as the source of the diagnostic.

## 2.0.3:

**Issue 354 (cont)** Unbreak autocompletions while typing code.

## 2.0.2:

**Issue 354 (cont)**: Unbreak `enable_auto_check` and `enable_auto_lint`. Due to the way that backend-based text commands work, if the source inspector is active, these commands become disabled. Moved the source rescan in `on_post_save` until all other work has been queued up so that the source inspector isn't active and things work as expected.

**Issue 360**: Added checks to the settings loader (`SettingsContainer.load()`) to check for dippy misspellings, like `add_to_path` vice `add_to_PATH`, validate the `prettify_executable` name.

## 2.0.1:

Updates to the *2.0.0* release, courtesy of @dten:

**Pull #355**: Call `Utils.encode_bytes` for empty strings. 

**Pull #356**: Comment out `install-dir` because there isn't a reasonable default. Net effect is that the user will get a diagnostic message because `install-dir` is expected in conjunction with `exec-with`.

**Pull #357**: Use the `edit_settings` Sublime command for side-by-side default and user settings editing.

**Pull #358**: Bump accepted maximum `hsdev` version number. This probably fixes `hsdev` backend issues that at least one user encountered.

## 2.0.0: Backend Refactoring and Lazy Backend Loading

__PLEASE RESTART SublimeText AFTER INSTALLING THIS UPDATE!__

__CHECK YOUR SUBLIMEHASKELL USER PREFERENCES FOR DEPRECATED PREFERENCES!__

__PLEASE READ THESE RELEASE NOTES ALL OF THE WAY THROUGH!__

__PLEASE RESTART SublimeText AFTER INSTALLING THIS UPDATE!__


*SublimeHaskell 2.0.0* is a significant refactoring of the original *SublimeHaskell* plugin to support a frequently requested enhancement: lazy backend loading. "Lazy backend loading" means that *SublimeHaskell* will not start the `hsdev` or `ghc-mod` backend until the first Haskell or Cabal file gets focus. This resolves the issue where *SublimeHaskell* started the backend regardless of whether Haskell or Cabal source is being edited. It may seem like a reasonably simple enhancement -- it required redesigning and reimplementing how *SublimeHaskell* interacts with its backends.

*SublimeHaskell* supports three backends: `hsdev`, `ghc-mod` and `none`.

  - The `hsdev` backend is has the most robust feature set, including Haddock documentation in information
    popups, *"Add Import"/"Insert Import for Symbol"* and *"Clean Imports*. The `ghc-mod` backend does not
    support these specific advanced features.

  - The `ghc-mod` backend is lighter weight than `hsdev` at the expense of some advanced features.

  - You can use *SublimeHaskell* without a backend: edit and build with the `none` backend --
    you give up completions, checking and linting.

  - You can switch between backends on-the-fly (not recommended for daily use.)

  - You can start, stop and restart the current backend.

  - Execution wrappers (`cabal exec` and `stack exec`) can be used to start the `hsdev` backend and its associated
    utilities. **Note**: This does not and cannot work for the `ghc-mod` backend because `ghc-mod` has to execute
    in the Haskell project's directory. `hsdev` does not have this restriction.

*SublimeHaskell* will always revert to the `none` backend if it can't start the `hsdev` or `ghc-mod` backends correctly.

**`hdevtools` backend deprecated**: There has been no active development on this backend for over a year (more, actually.) Moreover, `hdevtools` didn't support many features, such as completion queries. Feel free to create an enhancement request if you really want `hdevtools` backend support.

**Deprecated Settings**: The following settings are now deprecated: `enable_hsdev`, `enable_ghc_mod`, `enable_hdevtools`, `hdevtools_socket`, `hsdev_host`, `hsdev_local_process`, and `hsdev_port`. *SublimeHaskell* will remind you with a message when it starts up if it finds these settings in your preferences.

**Default `backends` Settings**: The new `backends` setting replaces all of the deprecated settings. *SublimeHaskell*'s default backend is a local `hsdev` server. Other configurations include *"Cabal-sandboxed local hsdev"* that executes a `hsdev` server installed in a cabal sandbox, and *"Stack-exec local hsdev"* executes a `hsdev` server built in a `stack` sandbox.

For reference, the plugin's default `backends` setting looks like:

    "backends": {
        "Local hsdev": {
            "default": true,
            "backend": "hsdev",
            "options": {
              "local": true,
              "port": 4567
            }
        },
        "ghc-mod": {
            "default": false,
            "backend": "ghc-mod"
        },
        "Remote hsdev@localhost:4567": {
            "default": false,
            "backend": "hsdev",
            "options": {
                "local": false,
                "host": "localhost",
                "port": 4567
            }
        },
        "Cabal-sandboxed local hsdev": {
            "default": false,
            "backend": "hsdev",
            "options": {
              "local": true,
              "exec-with": "cabal",
              "install-dir": "$HOME/play/haskell/hsdev"
            }
        },
        "Stack-exec local hsdev": {
            "default": false,
            "backend": "hsdev",
            "options": {
              "local": true,
              "port": 4567,
              "exec-with": "stack",
              "install-dir": "$HOME/play/haskell/hsdev"
            }
        },
        "No backend": {
            "default": false,
            "backend": "none"
        }
    }

**Backend options**: The `ghc-mod` and `none` backends do not have additional options and ignore whatever options are supplied. The `hsdev` backend supports the following options:

    port:        [default: "4567"]      TCP port where SublimeHaskell will connect to hsdev
    host:        [defualt: "localhost"] Host name SublimeHaskell will connect to hsdev
    local:       [default: true]        Should SublimeHaskell create a local hsdev server process? Specify false
                                        if you want to connect to a remote hsdev server
    exec-with:   [no default]           Should SublimeHaskell use "stack" or "cabal" to when starting the hsdev
                                        executable? Valid options are "stack" and "cabal".
    install-dir: [no default]           Used in conjunction with "exec-with"; this is the directory where
                                        SublimeHaskell go to "cabal exec" or "stack exec" the hsdev executable.

## Other Fixes/Features

**Pull #351**: Accept *Haskell.sublime-syntax* as a Haskell source code indicator. (H/T to *dten*)

**Pull #350**: Fix fly-checking view. Variable shadowed a parameter, which was definitely the wrong thing. (H/T to *dten*, although there is more work to do to make fly checking work.)

**Pull #340**: Activate the stack config switcher, contributed by Xavier Denis (*xldenis*).

**Issue #271**: Insert import for symbol is silently failed due to a change in the ST3 API.

**Issue #345**: Prettify buffer contents on save. Adds two new settings, `prettify_on_save` (true/false, default false) and `prettify_executable` ("stylish-haskell"|"hindent", default is "stylish-haskell").

## Upcoming Development Milestones

Upcoming development milestones, listed in order of priority:

### SublimeText 3 Syntax Files (Expected: 2.1.0)

There are numerous issues related to syntax highlighting. Syntax highlighting in SublimeText 2 was driven by collections of regular expressions. SublimeText 3 syntax highlighting still uses regexps and offers the ability to be more stateful. However, transitioning from _SublimeHaskell_'s improved ST2 syntax highlighting to ST3 syntax highlighting requires substantial work.

### The SublimeHaskell Editing Guide (Ongoing)

Documentation is always a good thing. The guide is a work-in-progress.
