*SublimeHaskell* 2.1.3
======================

SublimeHaskell 2.1.x is a release tree for minor enhancements and newly identified (and resolved) issues.

## In this release

**SublimeHaskell: Run**: Make running project executables play nicely with execution wrappers (e.g., `cabal run`, `stack exec`, `cabal new-run`). Eliminated the 'SublimeHaskell: Stack Exec' item because all of the functionality is included in 'SublimeHaskell: Run'. This change eliminates all of the previous gymnastics required to locate the executable in the first place.

`SublimeHaskell: Run` will also prompt for command line arguments, which are parsed into a Python list by the `shlex` package. Arguments will persist across command invocations and Sublime Text sessions.

**Issue 365**: More linting on the `prettify_exectable` setting. Someday, we'll know where the "{0}" comes from.

**Issue 361**: Add `cabal new-test` support in the `SublimeHaskell: Test` command. Restored automatic testing after a successful build; automatic benchmarking is also possible after a successful build. See **auto_build_mode** note below.

**Issue 344**: Most, if not all, 'cabal new-*' commands should be available, including `new-freeze` and `new-bench`. Corresponding commands for regular `cabal` and `stack` (as applicable) implemented. The major hack is that `cabal-new-build` does not have a clean command, so this is implemented as a function inside the SublimeHaskell builder.

**auto_build_mode change**: The `auto_run_tests` setting is now deprecated. Its functionality is now replaced by two new build modes: *normal-then-test* (run tests after a successful build) and *normal-then-bench* (run benchmarks after a successful build.) SublimeHaskell will pop up an information dialog if `auto_run_tests` is in your preferences.

**Project Settings**: All SublimeHaskell-related project settings are now contained within the `SublimeHaskell` dictionary. This allows you to encapsulate certain settings, like `haskell_build_tool`, on a per-project basis instead of via user preferences. There is more information at the bottom of the `SublimeHaskell.sublime-settings` (default plugin settings) file.

    {
      "folders":
      [
        {
          "path": "."
        }
      ],
      "SublimeHaskell": {
        "haskell_build_tool": "cabal-new-build"
      }
    }

**build.py**: Code cleanups related to building Haskell applications, mostly related to better class structure, fewer global variables. (Related to issues 361 and 344.)

**`pylint` cleanups**: `pylint` has updated, lots of new warnings. Fix code to bring them down to a dull roar.

## 2.1.2

**Issue 366**: Word and default completions did not produce results, which became apparent while using the "none" backend. Removed the `inhibit_completions` setting because its purpose was confusing. Added two new settings, `add_word_completions` and `add_default_completions`. `add_word_completions` adds words in the source file that are more than three characters; this is a SublimeText feature that SublimeHaskell normally inhibits. `add_default_completions` adds the contents of the `Haskell.sublime-completions` file, which SublimeHaskell normally inhibits as well. Both settings default to `false`. (H/T to @Pastafarianist.)

## 2.1.1

**ghc-mod**: Completions now work again, modeled off the `ghc-mod/elisp/ghc-comp.el` code. It's not perfect, but it suffices to improve developer productivity.

**Issue 365 (partial)**: Fix dignostic message when SublimeHaskell doesn't accept the `prettify_executable` setting's value.

**Issue 364**: `SublimeHaskell: Test` actually invoked the `install` task, not the `test` task. Also added `SublimeHaskell - Test` to the "Build With..." menu. Issue fixed.

## 2.1.0

**Issue 352**: Add command line options for `stylish-haskell` and `hindent`. NOTE: These are lists, not strings.

## Upcoming Development Milestones

Upcoming development milestones, listed in order of priority:

### SublimeText 3 Syntax Files (Expected: 2.2.0)

There are numerous issues related to syntax highlighting. Syntax highlighting in SublimeText 2 was driven by collections of regular expressions. SublimeText 3 syntax highlighting still uses regexps and offers the ability to be more stateful. However, transitioning from _SublimeHaskell_'s improved ST2 syntax highlighting to ST3 syntax highlighting requires substantial work.

### The SublimeHaskell Editing Guide (Ongoing)

Documentation is always a good thing. The guide is a work-in-progress.
